sheet.outlineColumn.options({columnIndex: index}) 속성을 사용하여 데이터를 트리 보기로 표시합니다. 그룹 표시기를 클릭하면 열을 확장하거나 축소할 수 있습니다.
기본 제공 increaseCellIndent 및 decreaseCellIndent 명령을 사용하여 계층 데이터를 변경합니다.
Increase Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 늘리려면 키보드 바로 가기 'ctrl-atl-]'를 사용합니다.
Decrease Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 줄이려면 키보드 바로 가기 'ctrl-atl-['를 사용합니다. expandIndicator 또는 collapseIndicator 옵션을 사용하여 확장 및 축소 표시기를 사용자 정의합니다.
표시기를 확장 및 축소하려면 expandIndicator 또는 collapseIndicator 옵션을 사용합니다.
images 및 showImage 옵션을 사용하여 각 수준에 표시된 이미지를 사용자 정의할 수 있습니다.
showCheckBox 옵션을 사용하여 각 행의 확인란 표시 여부 상태를 사용자 정의합니다. 셀의 확인란을 선택하거나 해제하면 해당 하위 확인란의 상태도 모두 영향을 받습니다.
maxLevel 옵션을 사용하여 데이터 계층 수준을 제어할 수 있습니다. 기본 maxLevel은 10입니다.
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 2 });
initSpread(spread);
};
function initSpread(spread) {
var sheet = spread.getActiveSheet();
sheet.suspendPaint();
loadData(sheet);
initOutlineColumn(sheet);
setOutlineColumnOptions(sheet);
sheet.getRange(0,3,25,3).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.resumePaint();
}
function loadData(sheet) {
var sd = data;
sheet.setDataSource(sd);
sheet.setColumnCount(6);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 350);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 150);
sheet.setColumnWidth(4, 150);
sheet.setColumnWidth(5, 150);
for (var r = 0; r < sd.length; r++) {
var level = sd[r].level;
if(level==0)
{
sheet.getRange(r,0,1,7).backColor("#CCCCCC");
}
else if(level==1)
{
sheet.getRange(r,0,1,7).backColor("#EEEEEE");
}
sheet.getCell(r, 0).textIndent(level);
}
}
const defaultImages = ['$DEMOROOT$/spread/source/images/task-1.png', '$DEMOROOT$/spread/source/images/task-2.png', '$DEMOROOT$/spread/source/images/task-3.png'];
const defaultExpandIndicator = '$DEMOROOT$/spread/source/images/increaseIndicator.png';
const defaultCollapseIndicator = '$DEMOROOT$/spread/source/images/decreaseIndicator.png';
function initOutlineColumn(sheet) {
sheet.outlineColumn.options({
columnIndex: 0,
showImage: true,
showCheckBox: true,
images: defaultImages,
expandIndicator: defaultExpandIndicator,
collapseIndicator: defaultCollapseIndicator,
maxLevel: 2
});
sheet.showRowOutline(false);
sheet.outlineColumn.refresh();
}
function setOutlineColumnOptions(sheet) {
var picture1Url = defaultImages[0];
var picture2Url = defaultImages[1];
var picture3Url = defaultImages[2];
var indicator1Url = defaultExpandIndicator;
var indicator2Url = defaultCollapseIndicator;
var options = sheet.outlineColumn.options();
_getElementById('maxLevel').value = options.maxLevel;
_getElementById('showIndicator').addEventListener('change', function() {
sheet.outlineColumn.options().showIndicator = _getElementById('showIndicator').checked;
sheet.outlineColumn.refresh();
});
_getElementById('showCheckBox').addEventListener('change', function() {
sheet.outlineColumn.options().showCheckBox = _getElementById('showCheckBox').checked;
sheet.outlineColumn.refresh();
});
_getElementById('showImage').addEventListener('change', function() {
sheet.outlineColumn.options().showImage = _getElementById('showImage').checked;
sheet.outlineColumn.refresh();
});
_getElementById('customIndicator').addEventListener('change', function() {
if (!_getElementById('customIndicator').checked) {
_getElementById('setIndicators').setAttribute('disabled', true);
_getElementById('indicator1').setAttribute('disabled', true);
_getElementById('indicator2').setAttribute('disabled', true);
sheet.outlineColumn.options().expandIndicator = null;
sheet.outlineColumn.options().collapseIndicator = null;
sheet.outlineColumn.refresh();
} else {
_getElementById('setIndicators').removeAttribute('disabled');
_getElementById('indicator1').removeAttribute('disabled');
_getElementById('indicator2').removeAttribute('disabled');
_getElementById('setIndicators').addEventListener('click', _handel());
}
});
_getElementById('setIndicators').addEventListener('click', _handel);
function _handel(){
sheet.outlineColumn.options().expandIndicator =indicator1Url;
sheet.outlineColumn.options().collapseIndicator = indicator2Url;
sheet.outlineColumn.refresh();
}
_getElementById('setMaxLevel').addEventListener('click', function() {
sheet.outlineColumn.options().maxLevel = parseInt(_getElementById('maxLevel').value);
sheet.outlineColumn.refresh();
});
_getElementById('setImages').addEventListener('click', function() {
sheet.outlineColumn.options().images = [
picture1Url,
picture2Url,
picture3Url
];
sheet.outlineColumn.refresh();
});
_getElementById('image1').addEventListener('change', function() {
var file = this.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
var reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function(e) {
picture1Url = this.result;
};
});
_getElementById('image2').addEventListener('change', function() {
var file = this.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
var reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function(e) {
picture2Url = this.result;
};
});
_getElementById('image3').addEventListener('change', function() {
var file = this.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
var reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function(e) {
picture3Url = this.result;
};
});
_getElementById('indicator1').addEventListener('change', function() {
var file = this.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
var reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function(e) {
indicator1Url = this.result;
};
});
_getElementById('indicator2').addEventListener('change', function() {
var file = this.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
var reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function(e) {
indicator2Url = this.result;
};
});
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta name="spreadjs culture" content="ko-kr"/>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets-resources-ko/dist/gc.spread.sheets.resources.ko.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/outlineColumn-wbs.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
<label >OutlineColumn Options:</label>
</div>
<hr>
<div class="option-row">
<div class="option-row">
<input type="checkbox" id="showIndicator" checked="checked"/>
<label for="showIndicator">Show Indicator</label>
</div>
<div class="option-row">
<input type="checkbox" id="showCheckBox" checked="checked"/>
<label for="showCheckBox">Show CheckBox</label>
</div>
<div class="option-row">
<input type="checkbox" id="showImage" checked="checked"/>
<label for="showImage">Show Image</label>
</div>
<div class="option-row">
<input type="checkbox" id="customIndicator" checked="checked"/>
<label for="customIndicator" style="width: auto">Allow Custom Indicator</label>
</div>
<div class="option-row">
<label for="maxLevel" class="rightAlignLabel">Max level:</label>
<input type="text" id="maxLevel" style="width: 90px;"/>
</div>
<div class="option-row" style="padding-top: 6px">
<input type="button" id="setMaxLevel" value="Set"/>
</div>
</div>
<div class="option-row">
<label>Custom Image Settings:</label>
</div>
<hr>
<div class="option-row">
<label for="image1" class="rightAlignLabel"> Level 1 image: </label>
<input type="file" name="img1" id="image1" />
</div>
<div class="option-row">
<label for="image2" class="rightAlignLabel"> Level 2 image: </label>
<input type="file" name="img2" id="image2" />
</div>
<div class="option-row">
<label for="image3" class="rightAlignLabel"> Level 3 image: </label>
<input type="file" name="img3" id="image3" />
</div>
<div class="option-row" style="padding-top: 6px">
<input type="button" id="setImages" value="Set"/>
</div>
<div class="option-row">
<label>Custom Indicator Image Settings:</label>
</div>
<hr>
<div class="option-row">
<label for="indicator1" class="rightAlignLabel">Expanded image:</label>
<input type="file" name="in1" id="indicator1" />
</div>
<div class="option-row">
<label for="indicator2" class="rightAlignLabel">Collapsed image:</label>
<input type="file" name="in2" id="indicator2" />
</div>
<div class="option-row" style="padding-top: 6px">
<input type="button" id="setIndicators" value="Set"/>
</div>
</div>
</div></body>
</html>
.colorLabel {
background-color: #F4F8EB;
}
.rightAlignLabel {
width: 120px;
text-align: right;
margin-right: 8px;
}
input[type="text"] {
width: 190px;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
width: 190px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

sheet.outlineColumn.options({columnIndex: index}) 속성을 사용하여 데이터를 트리 보기로 표시합니다. 그룹 표시기를 클릭하면 열을 확장하거나 축소할 수 있습니다.
기본 제공 increaseCellIndent 및 decreaseCellIndent 명령을 사용하여 계층 데이터를 변경합니다.
Increase Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 늘리려면 키보드 바로 가기 'ctrl-atl-]'를 사용합니다.
Decrease Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 줄이려면 키보드 바로 가기 'ctrl-atl-['를 사용합니다. expandIndicator 또는 collapseIndicator 옵션을 사용하여 확장 및 축소 표시기를 사용자 정의합니다.
표시기를 확장 및 축소하려면 expandIndicator 또는 collapseIndicator 옵션을 사용합니다.
images 및 showImage 옵션을 사용하여 각 수준에 표시된 이미지를 사용자 정의할 수 있습니다.
showCheckBox 옵션을 사용하여 각 행의 확인란 표시 여부 상태를 사용자 정의합니다. 셀의 확인란을 선택하거나 해제하면 해당 하위 확인란의 상태도 모두 영향을 받습니다.
maxLevel 옵션을 사용하여 데이터 계층 수준을 제어할 수 있습니다. 기본 maxLevel은 10입니다.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ko';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
GC.Spread.Common.CultureManager.culture("ko-kr");
import './styles.css';
const spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
function loadData (sheet) {
let sd = data;
sheet.setDataSource(sd);
sheet.setColumnCount(6);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 350);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 150);
sheet.setColumnWidth(4, 150);
sheet.setColumnWidth(5, 150);
for (var r = 0; r < sd.length; r++) {
var level = sd[r].level;
if(level==0)
{
sheet.getRange(r,0,1,7).backColor("#CCCCCC");
}
else if(level==1)
{
sheet.getRange(r,0,1,7).backColor("#EEEEEE");
}
sheet.getCell(r, 0).textIndent(level);
}
}
const defaultImages = ['$DEMOROOT$/spread/source/images/task-1.png', '$DEMOROOT$/spread/source/images/task-2.png', '$DEMOROOT$/spread/source/images/task-3.png'];
const defaultExpandIndicator = '$DEMOROOT$/spread/source/images/increaseIndicator.png';
const defaultCollapseIndicator = '$DEMOROOT$/spread/source/images/decreaseIndicator.png';
function initOutlineColumn (sheet) {
sheet.outlineColumn.options({
columnIndex: 0,
showImage: true,
showCheckBox: true,
images: defaultImages,
expandIndicator: defaultExpandIndicator,
collapseIndicator: defaultCollapseIndicator,
maxLevel: 2
});
sheet.showRowOutline(false);
sheet.outlineColumn.refresh();
}
function setOutlineColumnOptions (sheet) {
let options = sheet.outlineColumn.options();
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
image1 = defaultImages[0];
image2 = defaultImages[1];
image3 = defaultImages[2];
indicator1 = defaultExpandIndicator;
indicator2 = defaultCollapseIndicator;
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor () {
this.maxLevel = "2";
this.allowCustomIndicator = true;
}
initSpread ($event: any) {
let spread = this.spread = $event.spread;
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
loadData(sheet);
initOutlineColumn(sheet);
setOutlineColumnOptions(sheet);
sheet.getRange(0,3,25,3).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.resumePaint();
}
showIndicator($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showIndicator = $event.target.checked;
sheet.outlineColumn.refresh();
}
showCheckBox($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showCheckBox = $event.target.checked;
sheet.outlineColumn.refresh();
}
showImage($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showImage = $event.target.checked;
sheet.outlineColumn.refresh();
}
setAllowCustomIndicator () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (!this.allowCustomIndicator) {
sheet.outlineColumn.options().expandIndicator = null;
sheet.outlineColumn.options().collapseIndicator = null;
sheet.outlineColumn.refresh();
}else{
sheet.outlineColumn.options().expandIndicator = this.indicator1;
sheet.outlineColumn.options().collapseIndicator = this.indicator2;
sheet.outlineColumn.refresh();
}
}
setCustomIndicator(){
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().expandIndicator = this.indicator1;
sheet.outlineColumn.options().collapseIndicator = this.indicator2;
sheet.outlineColumn.refresh();
}
setMaxLevel() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().maxLevel = parseInt(this.maxLevel);
sheet.outlineColumn.refresh();
}
setImages() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().images = [
this.image1,
this.image2,
this.image3
];
sheet.outlineColumn.refresh();
}
selectImage1(e: any) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.image1 = <string> this.result;
};
}
selectImage2(e: any) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.image2 = <string> this.result;
};
}
selectImage3(e: any) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.image3 = <string> this.result;
};
}
selectIndicator1(e: any) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.indicator1 = <string> this.result;
};
}
selectIndicator2(e: any) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.indicator2 = <string> this.result;
};
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {
}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/outlineColumn-wbs.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/ko/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/ko/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/ko/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet [dataSource]="dataSource" [autoGenerateColumns]='autoGenerateColumns'>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="options-row">
<label>OutlineColumn Options:</label>
</div>
<hr>
<div class="options-row">
<input type="checkbox" id="showIndicator" checked (change)="showIndicator($event)">
<label for="showIndicator" class="inlineLabel">Show Indicator</label>
</div>
<div class="options-row">
<input type="checkbox" id="showCheckBox" checked (change)="showCheckBox($event)">
<label for="showCheckBox"class="inlineLabel">Show CheckBox</label>
</div>
<div class="options-row">
<input type="checkbox" id="showImage" checked (change)="showImage($event)">
<label for="showImage"class="inlineLabel">Show Image</label>
</div>
<div class="options-row">
<input type="checkbox" id="allowCustomIndicator" [checked]="allowCustomIndicator" [(ngModel)]="allowCustomIndicator" (change)="setAllowCustomIndicator()">
<label for="allowCustomIndicator"class="inlineLabel">Allow Custom Indicator</label>
</div>
<div class="options-row">
<label for="maxLevel">Max Level:</label>
<input type="text" id="maxLevel" [(ngModel)]="maxLevel" [value]="maxLevel">
</div>
<div class="options-row">
<input type="button" value="Set" (click)="setMaxLevel()"/>
</div>
<div class="options-row">
<label>Custom Image Settings:</label>
</div>
<hr>
<div class="options-row">
<label for="image1">Label 1 image:</label>
<input type="file" name="img1" id="image1" (change)="selectImage1($event)"/>
</div>
<div class="options-row">
<label for="image2">Label 2 image:</label>
<input type="file" name="img2" id="image2" (change)="selectImage2($event)"/>
</div>
<div class="options-row">
<label for="image3">Label 3 image:</label>
<input type="file" name="img3" id="image3" (change)="selectImage3($event)"/>
</div>
<div class="options-row">
<input type="button" value="Set" (click)="setImages()">
</div>
<div class="options-row">
<label>Custom Indicator Image Settings:</label>
</div>
<hr>
<div class="options-row">
<label for="indicator1">Expanded Image:</label>
<input type="file" name="in1" id="indicator1" (change)="selectIndicator1($event)" [disabled]="!allowCustomIndicator"/> </div>
<div class="options-row">
<label for="indicator2">Collapsed Image:</label>
<input type="file" name="in2" id="indicator2" (change)="selectIndicator2($event)" [disabled]="!allowCustomIndicator"/> </div>
<div class="options-row">
<input type="button" value="Set" (click)="setCustomIndicator()" ng-disable="allowCustomIndicator" [disabled]="!allowCustomIndicator">
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
display: inline-block;
}
input[type="text"] {
padding: 4px 6px;
width: 100%;
margin-bottom: 10px;
}
input[type="button"] {
padding: 4px 6px;
width: 100%;
margin-bottom: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.inlineLabel {
display: inline-block;
}
#maxLevel {
width:90px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

sheet.outlineColumn.options({columnIndex: index}) 속성을 사용하여 데이터를 트리 보기로 표시합니다. 그룹 표시기를 클릭하면 열을 확장하거나 축소할 수 있습니다.
기본 제공 increaseCellIndent 및 decreaseCellIndent 명령을 사용하여 계층 데이터를 변경합니다.
Increase Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 늘리려면 키보드 바로 가기 'ctrl-atl-]'를 사용합니다.
Decrease Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 줄이려면 키보드 바로 가기 'ctrl-atl-['를 사용합니다. expandIndicator 또는 collapseIndicator 옵션을 사용하여 확장 및 축소 표시기를 사용자 정의합니다.
표시기를 확장 및 축소하려면 expandIndicator 또는 collapseIndicator 옵션을 사용합니다.
images 및 showImage 옵션을 사용하여 각 수준에 표시된 이미지를 사용자 정의할 수 있습니다.
showCheckBox 옵션을 사용하여 각 행의 확인란 표시 여부 상태를 사용자 정의합니다. 셀의 확인란을 선택하거나 해제하면 해당 하위 확인란의 상태도 모두 영향을 받습니다.
maxLevel 옵션을 사용하여 데이터 계층 수준을 제어할 수 있습니다. 기본 maxLevel은 10입니다.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="options-row">
<label>OutlineColumn Options:</label>
</div>
<div class="options-row">
<input type="checkbox" id="showIndicator" v-model="showIndicator">
<label for="showIndicator" class="inlineLabel">Show Indicator</label>
</div>
<div class="options-row">
<input type="checkbox" id="showCheckBox" v-model="showCheckBox">
<label for="showIndicator" class="inlineLabel">Show CheckBox</label>
</div>
<div class="options-row">
<input type="checkbox" id="showImage" v-model="showImage">
<label for="showIndicator" class="inlineLabel">Show Image</label>
</div>
<div class="options-row">
<input type="checkbox" id="allowCustomIndicator" v-model="allowCustomIndicator">
<label for="showIndicator" class="inlineLabel">Allow Custom Indicator</label>
</div>
<div class="options-row">
<label for="maxLevel">Max Level:</label>
<input type="text" id="maxLevel" v-model="maxLevel">
</div>
<div class="options-row">
<input type="button" value="Set" @click="setMaxLevel()" />
</div>
<div class="options-row">
<label>Custom Image Settings:</label>
</div>
<div class="options-row">
<label for="image1">Label 1 image:</label>
<input type="file" @change="selectImage1" id="image1">
</div>
<div class="options-row">
<label for="image2">Label 2 image:</label>
<input type="file" @change="selectImage2" id="image2">
</div>
<div class="options-row">
<label for="image3">Label 3 image:</label>
<input type="file" @change="selectImage3" id="image3">
</div>
<div class="options-row">
<input type="button" value="Set" @click="setImages()">
</div>
<div class="options-row">
<label>Custom Indicator Image Settings:</label>
</div>
<div class="options-row">
<label for="indicator1">Expanded Image:</label>
<input type="file" @change="selectIndicator1" id="indicator1" :disabled="!allowCustomIndicator">
</div>
<div class="options-row">
<label for="indicator2">Collapsed Image:</label>
<input type="file" @change="selectIndicator2" id="indicator2" :disabled="!allowCustomIndicator">
</div>
<div class="options-row">
<input type="button" value="Set" @click="setCustomIndicator()" :disabled="!allowCustomIndicator">
</div>
</div>
</div>
</template>
<script setup>
import { ref, watch } from "vue";
import "@mescius/spread-sheets-vue";
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
const spreadRef = ref(null);
const showIndicator = ref(true);
const showCheckBox = ref(true);
const showImage = ref(true);
const allowCustomIndicator = ref(true);
const maxLevel = ref(2);
const image1 = ref("/spreadjs/demos/spread/source/images/task-1.png");
const image2 = ref("/spreadjs/demos/spread/source/images/task-2.png");
const image3 = ref("/spreadjs/demos/spread/source/images/task-3.png");
const indicator1 = ref("/spreadjs/demos/spread/source/images/increaseIndicator.png");
const indicator2 = ref("/spreadjs/demos/spread/source/images/decreaseIndicator.png");
watch(showIndicator, (value) => {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showIndicator = value;
sheet.outlineColumn.refresh();
});
watch(showCheckBox, (value) => {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showCheckBox = value;
sheet.outlineColumn.refresh();
});
watch(showImage, (value) => {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showImage = value;
sheet.outlineColumn.refresh();
});
watch(allowCustomIndicator, (value) => {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
if (!value) {
sheet.outlineColumn.options().expandIndicator = null;
sheet.outlineColumn.options().collapseIndicator = null;
sheet.outlineColumn.refresh();
} else {
sheet.outlineColumn.options().expandIndicator = indicator1.value;
sheet.outlineColumn.options().collapseIndicator = indicator2.value;
sheet.outlineColumn.refresh();
}
});
let initSpread = function (spread) {
spreadRef.value = spread;
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
loadData(sheet);
initOutlineColumn(sheet);
setOutlineColumnOptions(sheet);
sheet.getRange(0, 3, 25, 3).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.resumePaint();
}
function setCustomIndicator(){
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().expandIndicator = indicator1.value;
sheet.outlineColumn.options().collapseIndicator = indicator2.value;
sheet.outlineColumn.refresh();
}
function setMaxLevel() {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().maxLevel = parseInt(maxLevel.value);
sheet.outlineColumn.refresh();
}
function setImages() {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().images = [
image1.value,
image2.value,
image3.value
];
sheet.outlineColumn.refresh();
}
function selectImage1(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
image1.value = this.result;
};
}
function selectImage2(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
image2.value = this.result;
};
}
function selectImage3(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
image3.value = this.result;
};
}
function selectIndicator1(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
indicator1.value = this.result;
};
}
function selectIndicator2(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
indicator2.value = this.result;
};
}
function loadData(sheet) {
let sd = data;
sheet.setDataSource(sd);
sheet.setColumnCount(6);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 350);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 150);
sheet.setColumnWidth(4, 150);
sheet.setColumnWidth(5, 150);
for (var r = 0; r < sd.length; r++) {
var level = sd[r].level;
if (level == 0) {
sheet.getRange(r, 0, 1, 7).backColor("#CCCCCC");
}
else if (level == 1) {
sheet.getRange(r, 0, 1, 7).backColor("#EEEEEE");
}
sheet.getCell(r, 0).textIndent(level);
}
}
function initOutlineColumn(sheet) {
sheet.outlineColumn.options({
columnIndex: 0,
showImage: true,
showCheckBox: true,
images: ['$DEMOROOT$/spread/source/images/task-1.png', '$DEMOROOT$/spread/source/images/task-2.png', '$DEMOROOT$/spread/source/images/task-3.png'],
expandIndicator: '$DEMOROOT$/spread/source/images/increaseIndicator.png',
collapseIndicator: '$DEMOROOT$/spread/source/images/decreaseIndicator.png',
maxLevel: 2
});
sheet.showRowOutline(false);
sheet.outlineColumn.refresh();
}
function setOutlineColumnOptions(sheet) {
let options = sheet.outlineColumn.options();
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
display: inline-block;
}
input[type="text"] {
width: 200px;
}
input[type="button"] {
padding: 4px 6px;
width: 100%;
margin-bottom: 10px;
}
label {
display: inline-block;
font-size: 13px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.desc {
padding: 2px 10px;
background-color: #F4F8EB;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/ko/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/ko/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script src="$DEMOROOT$/spread/source/data/outlineColumn-wbs.js" type="text/javascript"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/ko/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

sheet.outlineColumn.options({columnIndex: index}) 속성을 사용하여 데이터를 트리 보기로 표시합니다. 그룹 표시기를 클릭하면 열을 확장하거나 축소할 수 있습니다.
기본 제공 increaseCellIndent 및 decreaseCellIndent 명령을 사용하여 계층 데이터를 변경합니다.
Increase Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 늘리려면 키보드 바로 가기 'ctrl-atl-]'를 사용합니다.
Decrease Cell Indent Command: 셀 들여쓰기 및 행 그룹 수준을 줄이려면 키보드 바로 가기 'ctrl-atl-['를 사용합니다. expandIndicator 또는 collapseIndicator 옵션을 사용하여 확장 및 축소 표시기를 사용자 정의합니다.
표시기를 확장 및 축소하려면 expandIndicator 또는 collapseIndicator 옵션을 사용합니다.
images 및 showImage 옵션을 사용하여 각 수준에 표시된 이미지를 사용자 정의할 수 있습니다.
showCheckBox 옵션을 사용하여 각 행의 확인란 표시 여부 상태를 사용자 정의합니다. 셀의 확인란을 선택하거나 해제하면 해당 하위 확인란의 상태도 모두 영향을 받습니다.
maxLevel 옵션을 사용하여 데이터 계층 수준을 제어할 수 있습니다. 기본 maxLevel은 10입니다.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
const useState = React.useState, spreadNS = GC.Spread.Sheets;
function loadData(sheet) {
let sd = data;
sheet.setDataSource(sd);
sheet.setColumnCount(6);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 350);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 150);
sheet.setColumnWidth(4, 150);
sheet.setColumnWidth(5, 150);
for (var r = 0; r < sd.length; r++) {
var level = sd[r].level;
if (level == 0) {
sheet.getRange(r, 0, 1, 7).backColor("#CCCCCC");
}
else if (level == 1) {
sheet.getRange(r, 0, 1, 7).backColor("#EEEEEE");
}
sheet.getCell(r, 0).textIndent(level);
}
}
function initOutlineColumn(sheet) {
sheet.outlineColumn.options({
columnIndex: 0,
showImage: true,
showCheckBox: true,
images: ['$DEMOROOT$/spread/source/images/task-1.png', '$DEMOROOT$/spread/source/images/task-2.png', '$DEMOROOT$/spread/source/images/task-3.png'],
expandIndicator: '$DEMOROOT$/spread/source/images/increaseIndicator.png',
collapseIndicator: '$DEMOROOT$/spread/source/images/decreaseIndicator.png',
maxLevel: 2
});
sheet.showRowOutline(false);
sheet.outlineColumn.refresh();
}
function setOutlineColumnOptions(sheet) {
let options = sheet.outlineColumn.options();
}
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [state, setState] = useState({
maxLevel: 2,
image1: "/spreadjs/demos/spread/source/images/task-1.png",
image2: "/spreadjs/demos/spread/source/images/task-2.png",
image3: "/spreadjs/demos/spread/source/images/task-2.png",
indicator1: "/spreadjs/demos/spread/source/images/increaseIndicator.png",
indicator2: "/spreadjs/demos/spread/source/images/decreaseIndicator.png",
customIndicator: true
});
const initSpread = (spread) => {
setSpread(spread);
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
loadData(sheet);
initOutlineColumn(sheet);
setOutlineColumnOptions(sheet);
sheet.getRange(0, 3, 25, 3).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.resumePaint();
let options = sheet.outlineColumn.options();
setState(state => ({ ...state, maxLevel: options.maxLevel }));
setState(state => ({ ...state, image1: options.images[0] }));
setState(state => ({ ...state, image2: options.images[1] }));
setState(state => ({ ...state, image3: options.images[2] }));
setState(state => ({ ...state, indicator1: options.expandIndicator }));
setState(state => ({ ...state, indicator2: options.collapseIndicator }));
}
const showIndicator = (e) => {
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showIndicator = e.target.checked;
sheet.outlineColumn.refresh();
}
const showCheckBox = (e) => {
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showCheckBox = e.target.checked;
sheet.outlineColumn.refresh();
}
const showImage = (e) => {
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showImage = e.target.checked;
sheet.outlineColumn.refresh();
}
const customIndicator = (indicatorsInfo) => {
let sheet = spread.getActiveSheet();
setState(state => ({ ...state, customIndicator: indicatorsInfo }));
if (!indicatorsInfo) {
sheet.outlineColumn.options().expandIndicator = null;
sheet.outlineColumn.options().collapseIndicator = null;
sheet.outlineColumn.refresh();
} else {
sheet.outlineColumn.options().expandIndicator = state.indicator1;
sheet.outlineColumn.options().collapseIndicator = state.indicator2;
sheet.outlineColumn.refresh();
}
}
const setCustomIndicator = () => {
let sheet = spread.getActiveSheet();
if (state.customIndicator) {
sheet.outlineColumn.options().expandIndicator = state.indicator1;
sheet.outlineColumn.options().collapseIndicator = state.indicator2;
sheet.outlineColumn.refresh();
}
}
const setMaxLevel = (maxLevel) => {
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().maxLevel = parseInt(state.maxLevel);
sheet.outlineColumn.refresh();
}
const setImages = () => {
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().images = [
state.image1,
state.image2,
state.image3
];
sheet.outlineColumn.refresh();
}
const selectImage1 = (e) => {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
state.image1 = this.result;
};
}
const selectImage2 = (e) => {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
state.image2 = this.result;
};
}
const selectImage3 = (e) => {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
state.image3 = this.result;
};
}
const selectIndicator1 = (e) => {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
state.indicator1 = this.result;
};
}
const selectIndicator2 = (e) => {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
state.indicator2 = this.result;
};
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
maxLevel={state.maxLevel}
image1={state.image1}
image2={state.image2}
image3={state.image3}
indicator1={state.indicator1}
indicator2={state.indicator2}
showIndicator={(e) => showIndicator(e)}
showCheckBox={(e) => showCheckBox(e)}
selectImage1={(e) => selectImage1(e)}
selectImage2={(e) => selectImage2(e)}
selectImage3={(e) => selectImage3(e)}
selectIndicator1={(e) => selectIndicator1(e)}
selectIndicator2={(e) => selectIndicator2(e)}
showImage={(e) => showImage(e)}
customIndicator={(indicatorsInfo) => customIndicator(indicatorsInfo)}
setCustomIndicator={(indicatorsInfo) => setCustomIndicator(indicatorsInfo)}
setMaxLevel={(maxLevel) => setMaxLevel(maxLevel)}
setImages={(images) => setImages(images)}
customIndicatorState={state.customIndicator}
></Panel>
</div>
);
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e)
}} />
);
}
function TextInput(props) {
const [value, setValue] = useState(props.value);
return (
<input type="text" id={props.id} value={value} onChange={(e) => {
setValue(e.target.value);
props.onChange(e)
}} />
);
}
function Panel(props) {
const [maxLevel, setMaxLevel] = useState(props.maxLevel);
return (
<div className="options-container">
<div className="options-row">
<label>OutlineColumn Options:</label>
</div>
<hr />
<div className="options-row">
<CheckBoxInput id="showIndicator" checked={true} onChange={props.showIndicator}></CheckBoxInput>
<label htmlFor="showIndicator" className="inlineLabel">Show Indicator</label>
</div>
<div className="options-row">
<CheckBoxInput id="showCheckBox" checked={true} onChange={props.showCheckBox}></CheckBoxInput>
<label htmlFor="showCheckBox" className="inlineLabel">Show CheckBox</label>
</div>
<div className="options-row">
<CheckBoxInput id="showImage" checked={true} onChange={props.showImage}></CheckBoxInput>
<label htmlFor="showImage" className="inlineLabel">Show Image</label>
</div>
<div className="options-row">
<CheckBoxInput id="customIndicator" checked={true} onChange={(e) => {
props.customIndicator(e.target.checked);
}}></CheckBoxInput>
<label htmlFor="customIndicator" style={{ width: "auto" }} className="inlineLabel">Allow Custome Indicator</label>
</div>
<div className="options-row">
<label htmlFor="maxLevel">Max Level:</label>
<TextInput id="maxLevel" value={props.maxLevel} onChange={(e) => {
setMaxLevel(e.target.value);
}}></TextInput>
</div>
<div className="options-row">
<input type="button" value="Set" onClick={() => {
props.setMaxLevel(maxLevel)
}} />
</div>
<div className="options-row">
<label>Custom Image Settings:</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="img1">Label 1 image:</label>
<input type="file" name="img1" onChange={e => props.selectImage1(e)} />
</div>
<div className="options-row">
<label htmlFor="img2">Label 2 image:</label>
<input type="file" name="img2" onChange={e => props.selectImage2(e)} />
</div>
<div className="options-row">
<label htmlFor="img3">Label 3 image:</label>
<input type="file" name="img3" onChange={e => props.selectImage3(e)} />
</div>
<div className="options-row">
<input type="button" value="Set" onClick={() => { props.setImages() }} />
</div>
<div className="options-row">
<label>Custom Indicator Image Settings:</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="ind1">Expanded Image:</label>
<input type="file" name="ind1" onChange={e => props.selectIndicator1(e)} disabled={!props.customIndicatorState} />
</div>
<div className="options-row">
<label htmlFor="ind2">Collapsed Image:</label>
<input type="file" name="ind2" onChange={e => props.selectIndicator2(e)} disabled={!props.customIndicatorState} />
</div>
<div className="options-row">
<input type="button" value="Set" onClick={() => {
props.setCustomIndicator()
}} disabled={!props.customIndicatorState} />
</div>
</div>
);
}
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
const Component = React.Component, useState = React.useState, spreadNS = GC.Spread.Sheets;
function loadData(sheet) {
let sd = data;
sheet.setDataSource(sd);
sheet.setColumnCount(6);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 350);
sheet.setColumnWidth(2, 150);
sheet.setColumnWidth(3, 150);
sheet.setColumnWidth(4, 150);
sheet.setColumnWidth(5, 150);
for (var r = 0; r < sd.length; r++) {
var level = sd[r].level;
if (level == 0) {
sheet.getRange(r, 0, 1, 7).backColor("#CCCCCC");
}
else if (level == 1) {
sheet.getRange(r, 0, 1, 7).backColor("#EEEEEE");
}
sheet.getCell(r, 0).textIndent(level);
}
}
function initOutlineColumn(sheet) {
sheet.outlineColumn.options({
columnIndex: 0,
showImage: true,
showCheckBox: true,
images: ['$DEMOROOT$/spread/source/images/task-1.png', '$DEMOROOT$/spread/source/images/task-2.png', '$DEMOROOT$/spread/source/images/task-3.png'],
expandIndicator: '$DEMOROOT$/spread/source/images/increaseIndicator.png',
collapseIndicator: '$DEMOROOT$/spread/source/images/decreaseIndicator.png',
maxLevel: 2
});
sheet.showRowOutline(false);
sheet.outlineColumn.refresh();
}
function setOutlineColumnOptions(sheet) {
let options = sheet.outlineColumn.options();
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
maxLevel: 2,
image1: "/spreadjs/demos/spread/source/images/task-1.png",
image2: "/spreadjs/demos/spread/source/images/task-2.png",
image3: "/spreadjs/demos/spread/source/images/task-2.png",
indicator1: "/spreadjs/demos/spread/source/images/increaseIndicator.png",
indicator2: "/spreadjs/demos/spread/source/images/decreaseIndicator.png",
customIndicator: true
};
}
initSpread(spread) {
this.spread = spread;
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
loadData(sheet);
initOutlineColumn(sheet);
setOutlineColumnOptions(sheet);
sheet.getRange(0, 3, 25, 3).hAlign(GC.Spread.Sheets.HorizontalAlign.center);
sheet.resumePaint();
let options = sheet.outlineColumn.options();
this.setState({ maxLevel: options.maxLevel });
this.setState({ image1: options.images[0] });
this.setState({ image2: options.images[1] });
this.setState({ image3: options.images[2] });
this.setState({ indicator1: options.expandIndicator });
this.setState({ indicator2: options.collapseIndicator });
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
maxLevel={this.state.maxLevel}
image1={this.state.image1}
image2={this.state.image2}
image3={this.state.image3}
indicator1={this.state.indicator1}
indicator2={this.state.indicator2}
showIndicator={(e) => this.showIndicator(e)}
showCheckBox={(e) => this.showCheckBox(e)}
selectImage1={(e) => this.selectImage1(e)}
selectImage2={(e) => this.selectImage2(e)}
selectImage3={(e) => this.selectImage3(e)}
selectIndicator1={(e) => this.selectIndicator1(e)}
selectIndicator2={(e) => this.selectIndicator2(e)}
showImage={(e) => this.showImage(e)}
customIndicator={(indicatorsInfo) => this.customIndicator(indicatorsInfo)}
setCustomIndicator={(indicatorsInfo) => this.setCustomIndicator(indicatorsInfo)}
setMaxLevel={(maxLevel) => this.setMaxLevel(maxLevel)}
setImages={(images) => this.setImages(images)}
customIndicatorState={this.state.customIndicator}
></Panel>
</div>
);
}
showIndicator(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showIndicator = e.target.checked;
sheet.outlineColumn.refresh();
}
showCheckBox(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showCheckBox = e.target.checked;
sheet.outlineColumn.refresh();
}
showImage(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().showImage = e.target.checked;
sheet.outlineColumn.refresh();
}
customIndicator(indicatorsInfo) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
this.setState({
customIndicator: indicatorsInfo
})
if (!indicatorsInfo) {
sheet.outlineColumn.options().expandIndicator = null;
sheet.outlineColumn.options().collapseIndicator = null;
sheet.outlineColumn.refresh();
} else {
sheet.outlineColumn.options().expandIndicator = this.state.indicator1;
sheet.outlineColumn.options().collapseIndicator = this.state.indicator2;
sheet.outlineColumn.refresh();
}
}
setCustomIndicator() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (this.state.customIndicator) {
sheet.outlineColumn.options().expandIndicator = this.state.indicator1;
sheet.outlineColumn.options().collapseIndicator = this.state.indicator2;
sheet.outlineColumn.refresh();
}
}
setMaxLevel(maxLevel) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().maxLevel = parseInt(this.state.maxLevel);
sheet.outlineColumn.refresh();
}
setImages() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.outlineColumn.options().images = [
this.state.image1,
this.state.image2,
this.state.image3
];
sheet.outlineColumn.refresh();
}
selectImage1(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.state.image1 = this.result;
};
}
selectImage2(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.state.image2 = this.result;
};
}
selectImage3(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.state.image3 = this.result;
};
}
selectIndicator1(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.state.indicator1 = this.result;
};
}
selectIndicator2(e) {
let file = e.target.files[0];
if (!/image\/\w+/.test(file.type)) {
alert('The file must be an image!');
return false;
}
let self = this;
let reader = new FileReader();
reader.readAsDataURL(file);
reader.onload = function (e) {
self.state.indicator2 = this.result;
};
}
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e)
}} />
);
}
function TextInput(props) {
const [value, setValue] = useState(props.value);
return (
<input type="text" id={props.id} value={value} onChange={(e) => {
setValue(e.target.value);
props.onChange(e)
}} />
);
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
let props = this.props;
return (
<div className="options-container">
<div className="options-row">
<label>OutlineColumn Options:</label>
</div>
<hr />
<div className="options-row">
<CheckBoxInput id="showIndicator" checked={true} onChange={props.showIndicator}></CheckBoxInput>
<label htmlFor="showIndicator" className="inlineLabel">Show Indicator</label>
</div>
<div className="options-row">
<CheckBoxInput id="showCheckBox" checked={true} onChange={props.showCheckBox}></CheckBoxInput>
<label htmlFor="showCheckBox" className="inlineLabel">Show CheckBox</label>
</div>
<div className="options-row">
<CheckBoxInput id="showImage" checked={true} onChange={props.showImage}></CheckBoxInput>
<label htmlFor="showImage" className="inlineLabel">Show Image</label>
</div>
<div className="options-row">
<CheckBoxInput id="customIndicator" checked={true} onChange={(e) => {
props.customIndicator(e.target.checked);
}}></CheckBoxInput>
<label htmlFor="customIndicator" style={{ width: "auto" }} className="inlineLabel">Allow Custome Indicator</label>
</div>
<div className="options-row">
<label htmlFor="maxLevel">Max Level:</label>
<TextInput id="maxLevel" value={props.maxLevel} onChange={(e) => {
this.maxLevel = e.target.value
}}></TextInput>
</div>
<div className="options-row">
<input type="button" value="Set" onClick={() => {
props.setMaxLevel(this.maxLevel)
}} />
</div>
<div className="options-row">
<label>Custom Image Settings:</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="img1">Label 1 image:</label>
<input type="file" name="img1" onChange={e => props.selectImage1(e)} />
</div>
<div className="options-row">
<label htmlFor="img2">Label 2 image:</label>
<input type="file" name="img2" onChange={e => props.selectImage2(e)} />
</div>
<div className="options-row">
<label htmlFor="img3">Label 3 image:</label>
<input type="file" name="img3" onChange={e => props.selectImage3(e)} />
</div>
<div className="options-row">
<input type="button" value="Set" onClick={() => { props.setImages() }} />
</div>
<div className="options-row">
<label>Custom Indicator Image Settings:</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="ind1">Expanded Image:</label>
<input type="file" name="ind1" onChange={e => props.selectIndicator1(e)} disabled={!props.customIndicatorState} />
</div>
<div className="options-row">
<label htmlFor="ind2">Collapsed Image:</label>
<input type="file" name="ind2" onChange={e => props.selectIndicator2(e)} disabled={!props.customIndicatorState} />
</div>
<div className="options-row">
<input type="button" value="Set" onClick={() => {
props.setCustomIndicator()
}} disabled={!props.customIndicatorState} />
</div>
</div>
);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/outlineColumn-wbs.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/ko/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
/*margin-top: 10px;*/
}
input {
display: inline-block;
}
input[type="text"] {
padding: 4px 6px;
width: 100%;
margin-bottom: 10px;
}
input[type="button"] {
padding: 4px 6px;
width: 100%;
margin-bottom: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.inlineLabel {
display: inline-block;
}
#maxLevel {
width:90px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);